package ds

abstract class Deque[X]:
  /** Push an element to the front. */
  def pushFirst(elem: X): Deque[X]

  /** Pop an element from the front. */
  def popFirst: Option[(X, Deque[X])]

  /** Push an element to the back. */
  def pushLast(elem: X): Deque[X]

  /** Pop an element from the back. */
  def popLast: Option[(X, Deque[X])]

  /** Check whether the deque is empty. */
  def isEmpty: Boolean

case class DequeImpl[X](front: List[X], back: List[X]) extends Deque[X]:
  def pushFirst(elem: X): Deque[X] = ???
  def popFirst: Option[(X, Deque[X])] = ???
  def pushLast(elem: X): Deque[X] = ???
  def popLast: Option[(X, Deque[X])] = ???
  def isEmpty: Boolean = ???

object Deque:
  /** Create an empty deque. */
  def apply[X](): Deque[X] =
    ???

extension [X](deque: Deque[X])
  def popFirstAll: List[X] = deque.popFirst match
    case None           => Nil
    case Some(x, deque) => x :: deque.popFirstAll

  def popLastAll: List[X] = deque.popLast match
    case None           => Nil
    case Some(x, deque) => x :: deque.popLastAll
