package ds

abstract class Trie[X]:
  def find(key: String): Option[X]
  def delete(key: String): Trie[X]
  def insert(key: String, value: X): Trie[X]

case class TrieImpl[X](next: Map[Char, TrieImpl[X]], value: Option[X]) extends Trie[X]:
  def find(key: String): Option[X] = None
  def delete(key: String): TrieImpl[X] = this
  def insert(key: String, value: X): TrieImpl[X] = this

object TrieImpl:
  def apply[X](): TrieImpl[X] =
    ???
